var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
import * as React from 'react';
import A from '../a/index';
import cn from 'classnames';
import Spin from '../spin/index';
import './style.scss';
var Button = function (props) {
    var type = props.type, disabled = props.disabled, shrink = props.shrink, mini = props.mini, hollow = props.hollow, loading = props.loading, className = props.className, children = props.children, onClick = props.onClick, otherProps = __rest(props, ["type", "disabled", "shrink", "mini", "hollow", "loading", "className", "children", "onClick"]);
    var composeClassName = cn('x-button', {
        'x-button--disabled': disabled || loading,
        'x-button--mini': mini,
        'x-button--hollow': hollow,
        'x-button--shrink': shrink !== undefined ? shrink : !!mini,
    }, "x-button--" + type, className);
    var clickHandle = function (evt) {
        if (disabled || loading) {
            return;
        }
        onClick(evt);
    };
    return (React.createElement(A, __assign({}, otherProps, { className: composeClassName, onClick: clickHandle }),
        !!loading && React.createElement(Spin, { className: "x-button__loading" }),
        children));
};
Button.defaultProps = {
    type: 'primary',
};
export default Button;
