var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
import * as React from 'react';
import A from '../a/index';
import cn from 'classnames';
import './style.scss';
var CellRow = function (props) {
    var value = props.value, arrow = props.arrow, onClick = props.onClick, activeable = props.activeable, className = props.className, children = props.children, title = props.title, otherProps = __rest(props, ["value", "arrow", "onClick", "activeable", "className", "children", "title"]);
    var composeClassName = cn('x-cell__row', className, {
        'x-cell__row--activeable': onClick || activeable,
        'x-cell__row--arrow': arrow,
    });
    if (onClick) {
        var onClickHandle = function () {
            if (onClick) {
                onClick(value);
            }
        };
        return (React.createElement(A, __assign({}, otherProps, { className: composeClassName, onClick: onClickHandle }),
            title && React.createElement("label", null, title),
            children));
    }
    return (React.createElement("div", __assign({}, otherProps, { className: composeClassName }),
        title && React.createElement("label", null, title),
        children));
};
var CellTitle = function (props) {
    var text = props.text, className = props.className, otherProps = __rest(props, ["text", "className"]);
    var composeClassName = cn('x-cell__title', className);
    return (React.createElement("div", __assign({}, otherProps, { className: composeClassName }),
        React.createElement("h2", null, props.text)));
};
var Cell = function (props) {
    var arrow = props.arrow, indentLine = props.indentLine, className = props.className, children = props.children, onClick = props.onClick, otherProps = __rest(props, ["arrow", "indentLine", "className", "children", "onClick"]);
    var composeClassName = cn('x-cell', className, {
        'x-cell--indent-line': indentLine,
    });
    var composeChildren = [];
    if (Array.isArray(children)) {
        composeChildren.push.apply(composeChildren, children);
    }
    else {
        composeChildren.push(children);
    }
    return (React.createElement("section", __assign({}, otherProps, { className: composeClassName }), composeChildren.map(function (children, index) {
        if (children && children.type === CellRow) {
            return React.cloneElement(children, {
                key: index,
                arrow: arrow || children.props.arrow,
                onClick: onClick || children.props.onClick,
            });
        }
        return children;
    })));
};
Cell.Row = CellRow;
Cell.Title = CellTitle;
export default Cell;
