var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
import * as React from 'react';
import cn from 'classnames';
import Modal from '../modal/index';
import { createPortal } from 'react-dom';
import './style.scss';
var Dialog = /** @class */ (function (_super) {
    __extends(Dialog, _super);
    function Dialog(props) {
        var _this = _super.call(this, props) || this;
        _this.div = undefined;
        _this.div = document.createElement('div');
        _this.div.classList.add('_x_dialog_');
        document.body.appendChild(_this.div);
        return _this;
    }
    Dialog.prototype.componentWillUnmount = function () {
        if (this.div) {
            document.body.removeChild(this.div);
        }
    };
    Dialog.prototype.content = function () {
        var _a = this.props, className = _a.className, height = _a.height, visible = _a.visible, children = _a.children, onMaskClick = _a.onMaskClick, otherProps = __rest(_a, ["className", "height", "visible", "children", "onMaskClick"]);
        var composeClassName = cn('x-dialog', className);
        return (React.createElement(Modal, __assign({}, otherProps, { visible: visible, height: height, onMaskClick: onMaskClick, className: composeClassName }),
            React.createElement("div", { className: "x-dialog__inner" }, children)));
    };
    Dialog.prototype.render = function () {
        return this.div && createPortal(this.content(), this.div);
    };
    return Dialog;
}(React.Component));
var Scroller = function (props) {
    var className = props.className, children = props.children, otherProps = __rest(props, ["className", "children"]);
    var composeClassName = cn('x-dialog__scroller', className);
    return (React.createElement("div", __assign({}, otherProps, { className: composeClassName }),
        React.createElement("div", { className: "x-dialog__inscroller" }, children)));
};
Dialog.Scroller = Scroller;
export default Dialog;
