import * as React from 'react';
import { Times, TimeData } from './model';
import './style';
interface IProps {
    format: [string, string, string];
    data: TimeData[];
    interval?: number;
    defaultDay: Date;
    onChange: (data: Date) => void;
    className?: string;
}
interface IState {
    props: IProps;
    days: string[];
    currentDayValue: Date;
    currentDayIndex: number;
    times: Times;
    HHList: string[];
    currentHHValue: string;
    currentHHIndex: number;
    MMList: string[];
    currentMMValue: string;
    currentMMIndex: number;
    format: [string, string, string];
}
declare class TimePicker extends React.PureComponent<IProps, IState> {
    static getDerivedStateFromProps(props: IProps, state: IState): {
        times: Times;
        HHList: string[];
        MMList: string[];
        currentDayIndex: number;
        currentDayValue: Date;
        currentHHIndex: number;
        currentHHValue: string;
        currentMMIndex: number;
        currentMMValue: string;
        days: string[];
        props: {
            data: TimeData[];
            format: [string, string, string];
            interval?: number | undefined;
            defaultDay: Date;
            onChange: (data: Date) => void;
            className?: string | undefined;
        };
    } | null;
    private dayId;
    private iScrollDay;
    private iScrollDayY;
    private HHId;
    private iScrollHH;
    private iScrollHHY;
    private MMId;
    private iScrollMM;
    private iScrollMMY;
    private realScrollRowHeight;
    private needCalcList;
    constructor(props: IProps);
    componentDidMount(): void;
    componentWillUnmount(): void;
    componentDidUpdate(props: IProps): void;
    refresh(): void;
    reset(): void;
    getTime(): Date;
    setTime(time: Date): void;
    render(): JSX.Element;
    private initScrolls;
    private refreshScrolls;
    private renderDayList;
    private renderHHList;
    private renderMMList;
    private scrollEndCalc;
    private onChange;
    private destroyScrolls;
}
export default TimePicker;
