var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
import * as React from 'react';
import classnames from 'classnames';
import IScroll from 'iscroll/build/iscroll-lite';
import model from './model';
import './style';
var ID = 0;
var TimePicker = /** @class */ (function (_super) {
    __extends(TimePicker, _super);
    function TimePicker(props) {
        var _this = _super.call(this, props) || this;
        _this.iScrollDayY = 0;
        _this.iScrollHHY = 0;
        _this.iScrollMMY = 0;
        _this.needCalcList = {};
        // 初始化滚动插件
        _this.initScrolls = function () {
            // 初始化日期的滚动，并在添加滚动开始和滚动结束事件
            if (!_this.iScrollDay && _this.dayId) {
                var Key_1 = 'Day';
                _this.iScrollDay = new IScroll("#" + _this.dayId, {
                    disablePointer: true,
                    disableTouch: false,
                    disableMouse: false,
                });
                // 如果默认的index不是0，滚动它
                if (_this.state.currentDayIndex !== 0) {
                    _this.iScrollDay.scrollTo(0, -_this.realScrollRowHeight * _this.state.currentDayIndex, 0);
                }
                // 事件监听
                _this.iScrollDay.on('scrollStart', function () {
                    _this.iScrollDayY = _this.iScrollDay.y;
                    _this.needCalcList[Key_1] = true;
                });
                _this.iScrollDay.on('scrollEnd', function () {
                    if (typeof _this.iScrollDayY === 'undefined' || Math.abs(_this.iScrollDayY - _this.iScrollDay.y) === 0) {
                        return;
                    }
                    _this.scrollEndCalc(_this.iScrollDay, Key_1);
                });
            }
            // 初始化小时的滚动，并在添加滚动开始和滚动结束事件
            if (!_this.iScrollHH && _this.HHId) {
                var Key_2 = 'HHList';
                _this.iScrollHH = new IScroll("#" + _this.HHId, {
                    disablePointer: true,
                    disableTouch: false,
                    disableMouse: false,
                });
                // 如果默认的index不是0，滚动它
                if (_this.state.currentHHIndex !== 0) {
                    _this.iScrollHH.scrollTo(0, -_this.realScrollRowHeight * _this.state.currentHHIndex, 0);
                }
                // 事件监听
                _this.iScrollHH.on('scrollStart', function () {
                    _this.iScrollHHY = _this.iScrollHH.y;
                    _this.needCalcList[Key_2] = true;
                });
                _this.iScrollHH.on('scrollEnd', function () {
                    if (typeof _this.iScrollHHY === 'undefined' || Math.abs(_this.iScrollHHY - _this.iScrollHH.y) === 0) {
                        return;
                    }
                    _this.scrollEndCalc(_this.iScrollHH, Key_2);
                });
            }
            // 初始化分钟的滚动，并在添加滚动开始和滚动结束事件
            if (!_this.iScrollMM && _this.MMId && _this.props.interval !== 60 && _this.props.interval !== 0) {
                var Key_3 = 'MM';
                _this.iScrollMM = new IScroll("#" + _this.MMId, {
                    disablePointer: true,
                    disableTouch: false,
                    disableMouse: false,
                });
                // 如果默认的index不是0，滚动它
                if (_this.state.currentMMIndex !== 0) {
                    _this.iScrollMM.scrollTo(0, -_this.realScrollRowHeight * _this.state.currentMMIndex, 0);
                }
                // 事件监听
                _this.iScrollMM.on('scrollStart', function () {
                    _this.iScrollMMY = _this.iScrollMM.y;
                    _this.needCalcList[Key_3] = true;
                });
                _this.iScrollMM.on('scrollEnd', function () {
                    if (typeof _this.iScrollMMY === 'undefined' || Math.abs(_this.iScrollMMY - _this.iScrollMM.y) === 0) {
                        return;
                    }
                    _this.scrollEndCalc(_this.iScrollMM, Key_3);
                });
            }
        };
        // 刷新滚动条
        _this.refreshScrolls = function () {
            if (_this.iScrollDay) {
                _this.iScrollDay.refresh();
                _this.iScrollDay.scrollTo(0, -_this.realScrollRowHeight * _this.state.currentDayIndex, 300);
            }
            if (_this.iScrollHH) {
                _this.iScrollHH.refresh();
                _this.iScrollHH.scrollTo(0, -_this.realScrollRowHeight * _this.state.currentHHIndex, 300);
            }
            if (_this.iScrollMM) {
                _this.iScrollMM.refresh();
                _this.iScrollMM.scrollTo(0, -_this.realScrollRowHeight * _this.state.currentMMIndex, 300);
            }
        };
        // 滚动结束后的计算
        _this.scrollEndCalc = function (scroll, type) {
            if (_this.needCalcList[type]) {
                var row = Math.floor(-scroll.y / _this.realScrollRowHeight + 0.5);
                var scrollTop = row * _this.realScrollRowHeight;
                scroll.scrollTo(0, -scrollTop, 500);
                _this.needCalcList[type] = false;
                // 如果是日期滚动，更新小时和分钟数据
                if (type === 'Day') {
                    var times = model.transTimeList(model.getTimeList(_this.props.data[row]));
                    var hIndex_1 = times.HHList.indexOf(_this.state.currentHHValue);
                    var hChange = hIndex_1 === -1;
                    hIndex_1 = hIndex_1 > -1 ? hIndex_1 : 0;
                    var mIndex_1 = times.MMList[times.HHList[hIndex_1]].indexOf(_this.state.currentMMValue);
                    mIndex_1 = mIndex_1 > -1 ? mIndex_1 : 0;
                    // 如果小时变了，那分钟就恢复到默认第一个值
                    // 比如 4点45分 切换到另一天，另一天没有4点，则可能取了个0点
                    // 这个时候如果分钟不变，时间就变成了0点45分，其实是没意义的，不如直接展示0点0分
                    if (hChange) {
                        mIndex_1 = 0;
                    }
                    var hValue = times.HHList[hIndex_1];
                    var mList = times.MMList[hValue];
                    var mValue = mList[mIndex_1];
                    _this.setState({
                        times: times,
                        currentDayIndex: row,
                        currentDayValue: _this.props.data[row].day,
                        HHList: times.HHList,
                        currentHHIndex: hIndex_1,
                        currentHHValue: hValue,
                        MMList: mList,
                        currentMMIndex: mIndex_1,
                        currentMMValue: mValue,
                    }, function () {
                        if (_this.iScrollHH) {
                            _this.iScrollHH.refresh();
                            _this.iScrollHH.scrollTo(0, -hIndex_1 * _this.realScrollRowHeight, 0);
                        }
                        if (_this.iScrollMM) {
                            _this.iScrollMM.refresh();
                            _this.iScrollMM.scrollTo(0, -mIndex_1 * _this.realScrollRowHeight, 0);
                        }
                        _this.onChange();
                    });
                }
                else if (type === 'HHList') {
                    // 如果滚动的是小时，更新小时
                    // 分钟如果有相同的值，不动，不然则恢复到默认第一个值
                    var h = _this.state.HHList[row];
                    var mList = _this.state.times.MMList[h];
                    var mIndex_2 = mList.indexOf(_this.state.currentMMValue);
                    mIndex_2 = mIndex_2 > -1 ? mIndex_2 : 0;
                    _this.setState({
                        currentHHIndex: row,
                        currentHHValue: h,
                        MMList: mList,
                        currentMMIndex: mIndex_2,
                        currentMMValue: mList[mIndex_2],
                    }, function () {
                        if (_this.iScrollMM) {
                            _this.iScrollMM.refresh();
                            _this.iScrollMM.scrollTo(0, -mIndex_2 * _this.realScrollRowHeight, 0);
                        }
                        _this.onChange();
                    });
                }
                else if (type === 'MM') {
                    // 如果滚动的分钟，更新自身的值
                    _this.setState({
                        currentMMIndex: row,
                        currentMMValue: _this.state.MMList[row],
                    }, _this.onChange);
                }
            }
        };
        // 值改变的事件
        _this.onChange = function () {
            var date = _this.getTime();
            if (_this.props.onChange) {
                _this.props.onChange(date);
            }
        };
        // 删除全部iScroll
        _this.destroyScrolls = function () {
            if (_this.iScrollDay && _this.iScrollDay.destroy) {
                _this.iScrollDay.destroy();
            }
            if (_this.iScrollHH && _this.iScrollHH.destroy) {
                _this.iScrollHH.destroy();
            }
            if (_this.iScrollMM && _this.iScrollMM.destroy) {
                _this.iScrollMM.destroy();
            }
        };
        _this.state = {
            props: props,
            days: [],
            currentDayValue: new Date(),
            currentDayIndex: 0,
            times: { HHList: [], MMList: {} },
            HHList: [],
            currentHHValue: '',
            currentHHIndex: 0,
            MMList: [],
            currentMMValue: '',
            currentMMIndex: 0,
            format: _this.props.format,
        };
        // 定义id
        _this.dayId = "x-time-picker-day_" + ++ID;
        _this.HHId = "x-time-picker-hh_" + ++ID;
        _this.MMId = "x-time-picker-mm_" + ++ID;
        // 时间节点
        var HHList = [];
        for (var i = 0; i < 24; i++) {
            HHList.push(("00" + i).substr(-2));
        }
        // 时间间隔，必须能被60除尽
        var interval = _this.props.interval || 60;
        // 边界处理
        if (interval < 0 || interval > 60) {
            interval = 60;
        }
        if (60 % interval !== 0) {
            throw new Error('The props of "interval" must can be divided into 60.');
        }
        for (var _i = 0, _a = props.data; _i < _a.length; _i++) {
            var data = _a[_i];
            if (!model.isZeroTime(data.day)) {
                throw new Error('The "day" in "data" must a date with zero hour, zero minute and zero second.');
            }
        }
        if (props.defaultDay.getMinutes() % interval !== 0) {
            throw new Error('The "minute" in "defaultDay" must can be divided into "interval".');
        }
        var MMList = [];
        for (var i = 0; i < 60; i += interval) {
            MMList.push(("00" + i).substr(-2));
        }
        // 每一,行的高度（即li的高度）
        // todo 换用其他方式计算高度
        _this.realScrollRowHeight = window.rem ? (window.rem / 100) * 70 : 70;
        // todo HHList和MMList为一天24小时中的小时和分钟可选项，收到getTimeRange方法中去处理
        model.HHList = HHList;
        model.MMList = MMList;
        return _this;
    }
    TimePicker.getDerivedStateFromProps = function (props, state) {
        if (state.props.data !== props.data) {
            // 天列表
            var days = model.getDayList(props.data, props.format);
            // 时间数据
            var times = model.getStateByTime(props.defaultDay, props.data);
            return __assign({ days: days, props: __assign({}, state.props, { data: props.data }) }, times);
        }
        return null;
    };
    TimePicker.prototype.componentDidMount = function () {
        // 天列表
        var days = model.getDayList(this.props.data, this.props.format);
        // 时间数据
        var state = model.getStateByTime(this.props.defaultDay, this.props.data);
        this.setState({
            days: days,
            currentDayValue: state.currentDayValue,
            currentDayIndex: state.currentDayIndex,
            times: state.times,
            HHList: state.HHList,
            currentHHValue: state.currentHHValue,
            currentHHIndex: state.currentHHIndex,
            MMList: state.MMList,
            currentMMValue: state.currentMMValue,
            currentMMIndex: state.currentMMIndex,
        }, this.initScrolls);
    };
    TimePicker.prototype.componentWillUnmount = function () {
        this.destroyScrolls();
    };
    TimePicker.prototype.componentDidUpdate = function (props) {
        if (props.data !== this.props.data) {
            this.refreshScrolls();
        }
    };
    // 刷新滚动条
    TimePicker.prototype.refresh = function () {
        this.refreshScrolls();
    };
    // 恢复默认时间
    TimePicker.prototype.reset = function () {
        var state = model.getStateByTime(this.props.defaultDay, this.props.data);
        this.setState(__assign({}, state), this.refreshScrolls);
    };
    // 获取时间
    TimePicker.prototype.getTime = function () {
        var day = this.state.currentDayValue;
        var h = this.state.currentHHValue;
        var m = this.state.currentMMValue;
        return new Date(day.getFullYear(), day.getMonth(), day.getDate(), Number(h), Number(m));
    };
    // 设置时间
    TimePicker.prototype.setTime = function (time) {
        var state = model.getStateByTime(time, this.props.data);
        this.setState(__assign({}, state), this.refreshScrolls);
    };
    TimePicker.prototype.render = function () {
        var _a = this.props, data = _a.data, format = _a.format, interval = _a.interval, defaultDay = _a.defaultDay, onChange = _a.onChange, className = _a.className, otherProps = __rest(_a, ["data", "format", "interval", "defaultDay", "onChange", "className"]);
        var css = classnames('x-time-picker', className);
        return (React.createElement("div", __assign({}, otherProps, { className: css }),
            React.createElement("sup", { className: "x-time-picker__mask-t" }),
            React.createElement("sup", { className: "x-time-picker__mask-b" }),
            this.renderDayList(),
            this.renderHHList(),
            this.renderMMList()));
    };
    // 渲染天列表
    TimePicker.prototype.renderDayList = function () {
        return (React.createElement("div", { className: "x-time-picker__day-list", id: this.dayId },
            React.createElement("ul", null, this.state.days.map(function (i, index) {
                return React.createElement("li", { key: index }, i);
            }))));
    };
    // 渲染小时列表
    TimePicker.prototype.renderHHList = function () {
        var hFormat = this.state.format[1] || 'h点';
        return (React.createElement("div", { className: "x-time-picker__hh-list", id: this.HHId },
            React.createElement("ul", null, this.state.HHList.map(function (i, index) {
                var val = i + "\u70B9";
                if (/(h+)/.test(hFormat)) {
                    val = hFormat.replace(RegExp.$1, i);
                }
                return React.createElement("li", { key: index }, val);
            }))));
    };
    // 渲染分钟列表
    TimePicker.prototype.renderMMList = function () {
        if (this.props.interval === 60 || this.props.interval === 0) {
            return null;
        }
        var mFormat = this.state.format[2] || 'm分';
        return (React.createElement("div", { className: "x-time-picker__mm-list", id: this.MMId },
            React.createElement("ul", null, this.state.MMList.map(function (i, index) {
                var val = i + "\u5206";
                if (/(m+)/.test(mFormat)) {
                    val = mFormat.replace(RegExp.$1, i);
                }
                return React.createElement("li", { key: index }, val);
            }))));
    };
    return TimePicker;
}(React.PureComponent));
export default TimePicker;
